<?php
require_once ASD_APPLICATION_PATH . '/controllers/Abstract/Admin.php';

class Asd_Controller_AdminController
    extends Asd_Controller_Abstract_Admin
{
    public function init()
    {
        parent::init();

        // Header tabs
        $this->_view->layout->headerTabs = array(
            'admin' => array(
                'label' => __('Admin', 'amazon-bar-plugin'),
                'url' => 'admin.php?page=' . Asd_WpPlugin::SLUG,
            ),
            'options' => array(
                'label' => __('Options', 'amazon-bar-plugin'),
                'url' => 'admin.php?page=' . Asd_WpPlugin::SLUG . '-options',
            ),
        );
    }

    public function indexAction()
    {
        // Unpack dialog data
        if (isset($_POST['dialog_data'])) {
            parse_str($_POST['dialog_data'], $dialogData);
            $_POST = array_merge($_POST, $dialogData);
            unset($_POST['dialog_data']);
        }

        $form = Asd_Application::getForm('Admin')->load();

        try {
            if ($_POST) {
                if (!$form->isValidEx($_POST)) {
                    foreach ($form->getElements() as $element) {
                        foreach ($element->getMessages() as $message) {
                            $this->_addMessage(
                                $this->_view->escape(sprintf(_x('%1$s: %2$s', 'form error message template: %1$s - label, %2$s - message', 'amazon-bar-plugin'),
                                    $element->getLabel(), $message)),
                                'error');
                        }
                    }
                } else {
                    $form->save();
                }
            } else {
                $form->loadCategories();
            }
        } catch (Asd_Model_Amazon_Exception $e) {
            $this->_addMessage($this->_view->escape($e->getMessage()), 'error');
        }

        $form->prepare();

        return array(
            'form' => $form,
        );
    }

    public function optionsAction()
    {
        $form = Asd_Application::getForm('Options')->load();

        if ($_POST) {
            if (!$form->isValidEx($_POST)) {
                foreach ($form->getElements() as $element) {
                    foreach ($element->getMessages() as $message) {
                        $this->_addMessage(
                            $this->_view->escape(sprintf(_x('%1$s: %2$s', 'form error message template: %1$s - label, %2$s - message', 'amazon-bar-plugin'),
                                $element->getLabel(), $message)),
                            'error');
                    }
                }
            } else {
                try {
                    $form->save();
                    $this->_addMessage(__('Settings saved', 'amazon-bar-plugin'));
                } catch (Asd_Form_Options_Exception $e) {
                    $this->_addMessage(
                        $this->_view->escape($e->getMessage()),
                        'error');
                }
            }
        } else {
            $form->loadCategories();
        }

        $form->prepare();

        return array(
            'form' => $form,
        );
    }
}